-- LBP.lua

	
    
		function deepcopy(t)
			if type(t) ~= 'table' then return t end
			local mt = getmetatable(t)
			local res = {}
			for k,v in pairs(t) do
				if type(v) == 'table' then
					v = deepcopy(v)
				end
				res[k] = v
			end
			setmetatable(res,mt)
			return res
		end

-- Variablen
local NameOfProject = "Lazy Boss Preparation"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1;
local LBPMainframe 												-- dummy fuer das Hauptframe
local LBPConfigframe 
local showmode = false;

LBP = {}


LBP_DB = {															-- default Konfiguration,
																		-- wird whrend des Variabelnladens
																		-- ueberschrieben

};


local debugging = false


function LBP.echo( self, msg )												-- Beginn echo
																		-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)

end	

																-- Ende echo

																
																
function LBP.help( self )															-- Beginn help
	LBP.echo("LBP Hilfe")

end	

function LBP.CreateConfig(self)
	
	
	local frame = LBP:CreateFrame("frame", "LBPConfigFrame", UIParent, nil, "TOP", UIParent, "CENTER", -300, 350+25, 300, 500)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	--tinsert(UISpecialFrames,"LBPConfigFrame");

	
	local editcard = LBP:CreateFrame("frame", "editcard", frame, nil, "TOP", frame, "TOP", 0, -10, 1, 1)
	
	local editzone
	local editsubzone
	local editid
	
	function frame.SetTemplate(self, zone, subzone, id)
		editzone = zone;
		editsubzone = subzone;
		editid = id;
	end

	frame.close = LBP.CreateCloseButton(self, frame, "Config_CloseButton", 24, "TOPRIGHT", frame, "TOPRIGHT", -4, -4)
		frame.close:SetScript("OnClick", 
			function(self) 
				LBPMainFrame.zone = nil
				LBPMainFrame.subzone = nil
				showmode = false;
				frame:Hide()
				LBPMainframe:Check()
			end)
		


	frame.button = CreateFrame("BUTTON", "Button_CreateCard", frame, "UIPanelButtonTemplate")
		frame.button:SetText("Create Card")
		frame.button:SetWidth(80)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
	
	local zonetext = GetZoneText()
	local subzonetext = GetSubZoneText()
	
	if not InCombatLockdown() and subzonetext ~= "" then
		LBPMainFrame.zone = nil
		LBPMainFrame.subzone = nil
		local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		card = {};
		card["Name"] = subzonetext;
		
		card["Talents"] = LBP:GetTalentString();
		card["Spec"] = specid;
		card["Glyphs"] = {
			["1"] = {},
			["2"] = {}
		};
		for index,value in pairs(LBP:GetGlyphTable()) do
			card["Glyphs"][tostring(value[1])][value[2]] = value[3];
		end
		card["Macro1"] = "/script print(\"LBP Macro #1\")";
		card["Macro2"] = "/script print(\"LBP Macro #2\")";
		card["Macro3"] = "/script print(\"LBP Macro #3\")";
		card["Macro4"] = "/script print(\"LBP Macro #4\")";
		
		if not LBP_DB[zonetext] then LBP_DB[zonetext] = {} end
		if not LBP_DB[zonetext][subzonetext] then LBP_DB[zonetext][subzonetext] = {} end
		
		local id = time()
		
		LBP_DB[zonetext][subzonetext][id] = card;
	
		editzone = zonetext;
		editsubzone = subzonetext;
		editid = id;

	end	
	
	
	frame:Build()	
			end)
		frame.button:SetPoint("TOP", frame, "TOP", 0, 0)
		

		
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
	
	
	textbox:SetText("Config")
	

	
	
	
	
	local speclist_rahmen = LBP:CreateFrame("frame", "speclist_rahmen", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 100, 10)
		speclist_rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

	local speclist = {}
	
	for a=1,4 do
		local specid, specname, description, icon, background, role = GetSpecializationInfo(a);
		
		if specid then
			speclist[a] = LBP:CreateFrame("frame", "speclist", speclist_rahmen, nil, "TOPLEFT", speclist_rahmen, "TOPLEFT", 0, -(a-1)*36-8, 200, 36)
			--speclist[a].icon = LBP:CreateFrame("frame", "speclist_icon", speclist[a], nil, "LEFT", speclist[a], "LEFT", 10, 0, 32, 32)
--				speclist[a].icon:SetBackdrop({bgFile = icon });

				
		speclist[a].icon = speclist[a]:CreateTexture("speclist_icon"..a)
			speclist[a].icon:SetTexture(icon)
			speclist[a].icon:SetPoint("TOPLEFT",speclist[a],"LEFT", 10, 16 )
			speclist[a].icon:SetPoint("BOTTOMRIGHT",speclist[a],"LEFT", 42, -16 )
			speclist[a].icon:SetDesaturated(1)
			
				
			speclist[a].text = LBP:CreateFontString(speclist[a], "textbox","ARTWORK", "GameFontNormal", "LEFT", speclist[a].icon, "RIGHT", 10, 0, 300, 20, "LEFT", "MIDDLE", 1, 1, 1, 1)
			speclist[a].text:SetText(specname)
			speclist[a].text:SetWidth( speclist[a].text:GetStringWidth() )
			speclist_rahmen:SetWidth( math.max(speclist_rahmen:GetWidth(), speclist[a].text:GetWidth() + 10 +32 +10 +10))
			speclist_rahmen:SetHeight(a*36+16)
			
			speclist[a]:SetScript("OnEnter", function(self) speclist[a].text:SetText("|c00FFD100"..specname.."|r") speclist[a].icon:SetDesaturated(0) end)
			speclist[a]:SetScript("OnLeave", function(self) speclist[a].text:SetText("|c00FFFFFF"..specname.."|r") speclist[a].icon:SetDesaturated(1) end)
			
			speclist[a]:SetScript("OnMouseUp", function(self) speclist_rahmen:Hide() LBP_DB[editzone][editsubzone][editid]["Spec"] = specid frame:Build() end)
			--speclist[a]:SetScript("OnMouseUp", function(self) speclist_rahmen:Hide() print(editsubzone) frame:Build() end)
			
		end
	end
	speclist_rahmen:SetScript("OnMouseUp", function(self)
		self:Hide()
	end)
	tinsert(UISpecialFrames,"speclist_rahmen");
	
	speclist_rahmen:SetFrameStrata("TOOLTIP")
	speclist_rahmen:Hide()
	
	
	
	
	
	local list = LBP:CreateFrame("frame", "Liste", frame, nil, "TOP", textbox, "BOTTOM", 0, 0, 1, 1)

	
	

	
	
	
	
	local list_anker = LBP:CreateFrame("ScrollFrame", "List_Scroll", frame, "UIPanelScrollFrameTemplate", "TOPLEFT", frame, "TOPLEFT", 10, -30, 280, 160)

	
	
	frame.button_togglezones = CreateFrame("BUTTON", "Button_togglezones", frame, "UIPanelButtonTemplate")
		frame.button_togglezones:SetWidth(120)
		frame.button_togglezones:SetHeight(20)
		
		frame.button_togglezones:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 10, 10)
		
	frame.showzones = false;


	local glyphlist_rahmen = LBP:CreateFrame("frame", "glyphlist_rahmen", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 200, 300)
		glyphlist_rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		tinsert(UISpecialFrames,"glyphlist_rahmen");
	local glyphlist_anker = LBP:CreateFrame("ScrollFrame", "Glyphlist_Scroll", glyphlist_rahmen, "UIPanelScrollFrameTemplate", "TOPLEFT", glyphlist_rahmen, "TOPLEFT", 10, -10, 200-20-20, 280)

	local glyphlist = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist_anker, nil, "TOPLEFT", glyphlist_anker, "TOPLEFT", 0, 0, 1, 1)
	
		glyphlist.list = {}
		local n = 3;
		
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				tmpframe.icon = tmpframe:CreateTexture("glyphlist_icon")
				tmpframe.icon:SetTexture("Interface/BUTTONS/UI-EmptySlot")
				tmpframe.icon:SetTexture("Interface/PaperDoll/UI-Backpack-EmptySlot")
				tmpframe.icon:SetPoint("TOPLEFT",tmpframe,"LEFT", 0, 16 )
				tmpframe.icon:SetPoint("BOTTOMRIGHT",tmpframe,"LEFT", 32, -16 )
				--tmpframe.icon:SetTexCoord(0.25, 0.75, 0.25, 0.75)
				tmpframe.icon:SetDesaturated(1)
				
				--tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				--tmpframe.icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "LEFT", tmpframe, "LEFT", 42, 0, 100, 20, "LEFT", "MIDDLE", 1, 1, 1, 1)
				tmpframe.tb_name:SetText("egal")
				tmpframe:SetScript("OnEnter", function(self) tmpframe.tb_name:SetText("|c00FFD100".."egal".."|r") tmpframe.icon:SetDesaturated(0) end)
				tmpframe:SetScript("OnLeave", function(self) tmpframe.tb_name:SetText("|c00FFFFFF".."egal".."|r") tmpframe.icon:SetDesaturated(1) end)
				
				tmpframe.type = 1;
				tmpframe:Hide()
				
				glyphlist.list[1] = tmpframe;
				
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				tmpframe.icon = tmpframe:CreateTexture("glyphlist_icon")
				tmpframe.icon:SetTexture("Interface/PaperDoll/UI-Backpack-EmptySlot")
				tmpframe.icon:SetPoint("TOPLEFT",tmpframe,"LEFT", 0, 16 )
				tmpframe.icon:SetPoint("BOTTOMRIGHT",tmpframe,"LEFT", 32, -16 )
				--tmpframe.icon:SetTexCoord(0.25, 0.75, 0.25, 0.75)
				tmpframe.icon:SetDesaturated(1)
				--tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				--tmpframe.icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "LEFT", tmpframe, "LEFT", 42, 0, 100, 20, "LEFT", "MIDDLE", 1, 1, 1, 1)
				tmpframe.tb_name:SetText("egal")
				tmpframe:SetScript("OnEnter", function(self) tmpframe.tb_name:SetText("|c00FFD100".."egal".."|r") tmpframe.icon:SetDesaturated(0) end)
				tmpframe:SetScript("OnLeave", function(self) tmpframe.tb_name:SetText("|c00FFFFFF".."egal".."|r") tmpframe.icon:SetDesaturated(1) end)
				tmpframe.type = 2;
				tmpframe:Hide()
				
				glyphlist.list[2] = tmpframe;
		
		
		for a=1,GetNumGlyphs() do 
			local name, glyphType, isKnown, icon, castSpell,link, subText = GetGlyphInfo(a)
			
			if icon then 
			
				local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				--CreateTexture("speclist_icon"..a)
				--speclist[a].icon:SetTexture(icon)
				--:SetPoint("TOPLEFT",speclist[a],"LEFT", 10, 16 )
				--speclist[a].icon:SetPoint("BOTTOMRIGHT",speclist[a],"LEFT", 42, -16 )
				--tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				--tmpframe.icon:SetBackdrop({bgFile = icon});
				tmpframe.icon = tmpframe:CreateTexture("glyphlist_icon"..a)
				tmpframe.icon:SetTexture(icon)
				tmpframe.icon:SetPoint("TOPLEFT",tmpframe,"LEFT", 0, 16 )
				tmpframe.icon:SetPoint("BOTTOMRIGHT",tmpframe,"LEFT", 32, -16 )
				tmpframe.icon:SetDesaturated(1)
				
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "LEFT", tmpframe, "LEFT", 42, 0, 100, 20, "LEFT", "MIDDLE", 1, 1, 1, 1)
				tmpframe.tb_name:SetText(name)
				
				tmpframe:SetScript("OnEnter", function(self) tmpframe.tb_name:SetText("|c00FFD100"..name.."|r") tmpframe.icon:SetDesaturated(0) end)
				tmpframe:SetScript("OnLeave", function(self) tmpframe.tb_name:SetText("|c00FFFFFF"..name.."|r") tmpframe.icon:SetDesaturated(1) end)
				
				tmpframe.type = glyphType;
				tmpframe.id = castSpell;
				tmpframe:Hide()
				
				glyphlist.list[n] = tmpframe;
			n=n+1; 	
			end 
			
		end


	glyphlist:SetSize(250,32)
	glyphlist_anker:SetScrollChild(glyphlist)

	
	function glyphlist_rahmen:Build(icon, glyph_type)
		local n = 0;
		for index, value in pairs(glyphlist.list) do
			value:Hide()

			if value.icon:GetTexture() ~= icon then

				if value.type == glyph_type then
				value:Show()
				value:ClearAllPoints()
				value:SetPoint("TOPLEFT", glyphlist, "TOPLEFT", 0,-n*32)
				
				value:SetScript("OnMouseUp", 
					function(self) 
						LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(glyph_type)][icon] = nil;
						LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(glyph_type)][value.icon:GetTexture()] = value.id;
						glyphlist_rahmen:Hide()
						frame:Build()
					end
				)
				
				--LBP[editzone][editsubzone][editid]["Glyphs"][
				
				n=n+1;
				end
			end
			
		end
--		glyphlist:SetSize(250,32)
		--glyphlist_anker:SetScrollChild(glyphlist)
	--print(name)
--		print(glyph_type)
	end
	
	function glyphlist_rahmen:Toggle()
		if glyphlist_rahmen:IsVisible() then
			glyphlist_rahmen:Hide()
		else
			glyphlist_rahmen:Show()
		end
	end
	
	glyphlist_rahmen:SetFrameStrata("TOOLTIP")
	glyphlist_rahmen:Hide()
	
	
	











	
			
			
--	local card = deepcopy(LBP_DB[zone][subzone][id]);

	local editcard = LBP:CreateFrame("frame", "LBPMainFrame", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 600, 500)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	editcard:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	editcard:SetBackdropColor(0, 0, 0 , 1)
	
	--frame:Show()
	editcard.tb_name = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOPLEFT", 10, -15, 50, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_name:SetText("Name:")

	editcard.editname = LBP:CreateFrame("EditBox", "editcard_editname", editcard, "InputBoxTemplate", "LEFT", editcard.tb_name, "RIGHT", 20,0, 200, 50)
		editcard.editname:SetAutoFocus(false) 
		editcard.editname:SetJustifyH("LEFT");
		
			

	editcard.tb_zone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_name, "BOTTOMLEFT", 0, -15, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)

	editcard.tb_subzone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_zone, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_specframe = LBP:CreateFrame("frame", "editcard_specname", editcard, nil, "TOPLEFT", editcard.tb_subzone, "BOTTOMLEFT", 0, -5, 200, 20)
	editcard.tb_spec = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_subzone, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_specframe:SetScript("OnMouseUp", function(self)
		speclist_rahmen:ClearAllPoints()
		speclist_rahmen:SetPoint("TOP", editcard.tb_specframe, "BOTTOM")
		speclist_rahmen:Show()
	end)
	
	
	
	editcard.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()

		editcard.Talents[a] = tmpframe;
		editcard.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		editcard.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
	end

	editcard.Glyph = {};
	
	for a=1,6 do
	--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
	local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", mod(a,2)*50+50, -math.floor((a-1)/2)*50-50, 48-12*mod(a,2), 48-12*mod(a,2))
	
	
		function tmpframe:SetGlyph(tmp, tmp2)
			tmpframe:SetBackdrop({
				bgFile = tmp,
				tile = false, tileSize = height, edgeSize = 0,
				insets = { left = 0, right = 0, top = 0, bottom = 0 }
			})
			if tmp2 then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
	editcard.Glyph[a] = tmpframe;
	end

		editcard.button2 = CreateFrame("BUTTON", "SetThisNTC", editcard, "UIPanelButtonTemplate")
		editcard.button2:SetText("Change T/G/S to actual T/G/S")
		editcard.button2:SetWidth(180)
		editcard.button2:SetHeight(30)
		editcard.button2:SetScript("OnClick", 
			function(self) 
				local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
				if not LBP_DB[editzone] then LBP_DB[editzone] = {}; end -- that should not happen
				if not LBP_DB[editzone][editsubzone] then LBP_DB[editzone][editsubzone] = {}; end -- that should not happen
				--LBP_DB[zone][subzone][id] = {};
				LBP_DB[editzone][editsubzone][editid]["Talents"] = LBP:GetTalentString();
				LBP_DB[editzone][editsubzone][editid]["Spec"] = specname;
				LBP_DB[editzone][editsubzone][editid]["Glyphs"] = {["1"] = {}, ["2"] = {}, };
				for index,value in pairs(LBP:GetGlyphTable()) do
					LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(value[1])][value[2]] = value[3];
				end
				frame:Build()
			end)
		editcard.button2:SetPoint('TOP', editcard.tb_spec, 'BOTTOM', 0, -300)
		
	editcard.button3 = CreateFrame("BUTTON", "RemoveNTC", editcard, "UIPanelButtonTemplate")
		editcard.button3:SetText("Remove this card")
		editcard.button3:SetWidth(180)
		editcard.button3:SetHeight(30)
		editcard.button3:SetScript("OnClick", 
			function(self) 
				if LBP_DB[editzone][editsubzone][editid]["active"] then
					LBP_DB[editzone][editsubzone][editid] = nil;
					for index in pairs(LBP_DB[editzone][editsubzone]) do
						LBP_DB[editzone][editsubzone][index]["active"] = true
						break
					end
				else
					LBP_DB[editzone][editsubzone][editid] = nil;
				end
				
				local n = 0;
				for index in pairs(LBP_DB[editzone][editsubzone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[editzone][editsubzone] = nil; end
				
				n = 0;
				for index in pairs(LBP_DB[editzone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[editzone] = nil; end
				
				editzone = nil;
				editsubzone = nil;
				editid = nil;
				frame:Build()	
			end)
		editcard.button3:SetPoint('TOP', editcard.button2, 'BOTTOM', 0, -8)


		
		
	editcard.button4 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button4:SetText("Copy this Template to this zone")
		editcard.button4:SetWidth(180)
		editcard.button4:SetHeight(30)
		editcard.button4:SetScript("OnClick", 
			function(self) 
				if not LBP_DB[GetZoneText()] then LBP_DB[GetZoneText()] = {}; end
				if not LBP_DB[GetZoneText()][GetSubZoneText()] then LBP_DB[GetZoneText()][GetSubZoneText()] = {}; end
				newid = time()
				LBP_DB[GetZoneText()][GetSubZoneText()][newid] = deepcopy(LBP_DB[editzone][editsubzone][editid]);
				LBP_DB[GetZoneText()][GetSubZoneText()][newid]["active"] = false
				editzone = GetZoneText()
				editsubzone = GetSubZoneText()
				editid = newid
				
				frame:Build()
			end)
		editcard.button4:SetPoint('TOP', editcard.tb_spec, 'BOTTOM', 300, -300)


	
	
	editcard.macroframe1 = LBP:CreateFrame("frame", "Macroframe1", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4-48-8, -250, 48, 48);
	editcard.macroframe2 = LBP:CreateFrame("frame", "Macroframe2", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4, -250, 48, 48);
	editcard.macroframe3 = LBP:CreateFrame("frame", "Macroframe3", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4, -250, 48, 48);
	editcard.macroframe4 = LBP:CreateFrame("frame", "Macroframe4", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4+48+8, -250, 48, 48);


	
	
	function CreateMacroEditBox(self, name, parent, width, height)
	
	
	local scrollframe = LBP:CreateFrame("ScrollFrame", "ScrollFrame_"..name, parent, "UIPanelScrollFrameTemplate", "TOPLEFT", parent, "TOPLEFT", 0, 0, width, height)
		scrollframe.name = "Scrollframe";
			
	local scrollchild = CreateFrame("EditBox", "LBPEditBox_"..name, scrollframe) --, "InputBoxTemplate")
		scrollchild:SetPoint("TOPLEFT", scrollframe, "TOPLEFT", 8,-6)
		scrollchild:SetPoint("BOTTOMRIGHT", scrollframe, "BOTTOMRIGHT", -8,6)
		
		scrollchild:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		scrollchild:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		scrollchild:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)
		scrollchild:SetFont("Fonts\\ARIALN.TTF",14,"none")
		scrollchild:SetMultiLine(true)
		scrollchild:SetAutoFocus(false) 
		scrollchild:SetMaxLetters(255);
		scrollchild:SetCursorPosition(0)
		scrollchild:SetScript("OnCursorChanged", 
			function(self, x, y, width, height) 
				local d = -y-scrollframe:GetVerticalScroll()
				if d>13.9*4 or d<0 then 
					scrollframe:SetVerticalScroll(math.max(scrollframe:GetVerticalScroll()+13.99*d/abs(d),0)) 
					scrollframe:UpdateScrollChildRect()
				end 
			end
		)

		scrollframe:SetSize(width, height)--80-8-8)
		scrollchild:SetSize(width, height)
		scrollframe:SetScrollChild(scrollchild)
		
		--scrollframe:Hide()
		
		return scrollframe, scrollchild
	end
	
	
	
	editcard.tb_macro1 = LBP:CreateFontString(editcard, "tb_Macro1", "ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOP", 10, -10, 200, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_macro1:SetText("Macro 1")

		
		
	editcard.button_m1 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button_m1:SetText("Reset")
		editcard.button_m1:SetWidth(50)
		editcard.button_m1:SetHeight(30)
		editcard.button_m1:SetPoint("LEFT", editcard.tb_macro1, "RIGHT", 0, 0)		
		
		
	editcard.rahmen_macro1 = LBP:CreateFrame("frame", "Rahmen Macro1", editcard, nil, "TOPLEFT", editcard.tb_macro1, "BOTTOMLEFT", 0, 0, 280, 80)
		editcard.rahmen_macro1:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

	editcard.editbox_macro1, editcard.editbox_macro1_editbox = CreateMacroEditBox(self, "macro1", editcard.rahmen_macro1, 280-30-8, 80-8-8)
		editcard.editbox_macro1:SetPoint("TOPLEFT", editcard.rahmen_macro1, "TOPLEFT", 10,-8)



	editcard.tb_macro2 = LBP:CreateFontString(editcard, "tb_Macro2", "ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOP", 10, -110, 200, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_macro2:SetText("Macro 2")
		
	editcard.button_m2 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button_m2:SetText("Reset")
		editcard.button_m2:SetWidth(50)
		editcard.button_m2:SetHeight(30)
		editcard.button_m2:SetPoint("LEFT", editcard.tb_macro2, "RIGHT", 0, 0)

	editcard.rahmen_macro2 = LBP:CreateFrame("frame", "Rahmen Macro2", editcard, nil, "TOPLEFT", editcard.tb_macro2, "BOTTOMLEFT", 0, 0, 280, 80)
		editcard.rahmen_macro2:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

	editcard.editbox_macro2, editcard.editbox_macro2_editbox = CreateMacroEditBox(self, "macro2", editcard.rahmen_macro2, 280-30-8, 80-8-8)
		editcard.editbox_macro2:SetPoint("TOPLEFT", editcard.rahmen_macro2, "TOPLEFT", 10,-8)

	
		
			
	local list_entries = {}		

	local textbox
	local tmpframe

	
	for zone in pairs(LBP_DB) do
		if not list_entries[zone] then
			list_entries[zone] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
			list_entries[zone]:SetText("|c00aaaaaa"..zone.."|r")
		end
		
		for subzone in pairs(LBP_DB[zone]) do
			if not list_entries[subzone] then
				list_entries[subzone] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
				list_entries[subzone]:SetText("|c00aaaaaa  "..subzone.."|r")
			end
		
			for id, listcard in pairs(LBP_DB[zone][subzone]) do
				if not list_entries[id] then
					list_entries[id] = LBP:CreateFrame("frame", "test", list, nil, "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 30)
					list_entries[id].text =  LBP:CreateFontString(list_entries[id], "textbox","ARTWORK", "GameFontNormalLarge", "TOP", list_entries[id], "TOP", 0, 0, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
					list_entries[id].text:SetText("|c00ffffff    " .. listcard["Name"].."|r")
					
					list_entries[id]:SetScript("OnEnter", function(self) list_entries[id].text:SetText("|c00ffd100    " .. listcard["Name"].."|r") end)
					list_entries[id]:SetScript("OnLeave", function(self) 
						if id ~= editid then
							list_entries[id].text:SetText("|c00ffffff    " .. listcard["Name"].."|r") 
						end
					end)
						
					list_entries[id]:SetScript("OnMouseUp", function(self) 
						editzone = zone;
						editsubzone = subzone;
						editid = id;
				
						frame:Build()
					end)
				end	
				list_entries[id]:Hide()
				list_entries[id]:ClearAllPoints()
			end
		end
	end
	
function frame:Build()



	

list:SetHeight(1)


	if frame.showzones then
		frame.button_togglezones:SetText("Hide Subzones")
		frame.button_togglezones:SetScript("OnClick", function(self) frame.showzones = false; frame:Build(nil) end)
	else
		frame.button_togglezones:SetText("Show Subzones")
		frame.button_togglezones:SetScript("OnClick", function(self) frame.showzones = true; frame:Build(nil) end)
	end













	
	textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 1, "LEFT", "TOP", 1, 1, 1, 1)
	tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 1)
	
	
	list:SetHeight(list:GetHeight()+textbox:GetHeight())
		
	for zone,value in pairs(LBP_DB) do
		tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 20)
		--textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", tmpframe, "TOP", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
		--textbox:SetText("|c00aaaaaa"..zone.."|r")
		
		list_entries[zone]:ClearAllPoints()
		list_entries[zone]:SetPoint("TOP", tmpframe, "TOP")
		
		list:SetHeight(list:GetHeight()+textbox:GetHeight())
		
		for subzone,value in pairs(LBP_DB[zone]) do
		
			if frame.showzones then
				tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 20)
				--textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", tmpframe, "TOP", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
				--textbox:SetText("|c00aaaaaa  " .. subzone.."|r")
				
				
				list_entries[subzone]:ClearAllPoints()
				list_entries[subzone]:SetPoint("TOP", tmpframe, "TOP")
				list_entries[subzone]:Show()
				
				list:SetHeight(list:GetHeight()+textbox:GetHeight())
			else
				list_entries[subzone]:Hide()
			end
			
			
			
			
			for id, listcard in pairs(LBP_DB[zone][subzone]) do
			
				
				list_entries[id]:SetPoint("TOP", tmpframe, "BOTTOM", 0, 0, 280, 30)
				list_entries[id]:Show()
				
			
				tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 30)
				--LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 30)
				--list_entries[id] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", tmpframe, "TOP", 0, 0, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
				
			
				if id == editid then
					list_entries[id].text:SetText("|c00ffd100    " .. listcard["Name"].."|r")
				else
					list_entries[id].text:SetText("|c00ffffff    " .. listcard["Name"].."|r")
					--tmpframe:SetScript("OnEnter", function(self) list_entries[id]:SetText("|c00ffd100    " .. listcard["Name"].."|r") end)
					--tmpframe:SetScript("OnLeave", function(self) list_entries[id]:SetText("|c00ffffff    " .. listcard["Name"].."|r") end)
					--tmpframe:SetScript("OnMouseUp", function(self) 				editzone = zone;
				--editsubzone = subzone;
				--editid = id;
--			
				--frame:Build()
				--end)


				end
				list:SetHeight(list:GetHeight()+tmpframe:GetHeight())


--			frame:SetText(frame:GetText() .. "|c00aaaaaa  " .. value["Name"].."|r\n")
				--frame:SetText(frame:GetText() .. "|c00aaaaaa    " .. index.."|r\n")
				
				
		--[[		
	list.button = CreateFrame("BUTTON", "Test", list, nil)
		list.button:SetText("Test")
		list.button:SetWidth(280)
		list.button:SetHeight(30)
		list.button:SetPoint('TOP', textbox, 'TOP', 0, 0)
		list.button:SetScript("OnClick", 
			function(self) 
				editzone = zone;
				editsubzone = subzone;
				editid = id;
			
				frame:Build()
			end)
			--]]
			end
			end
	end
	
	list_anker:SetSize(260, 430)
	--list:SetHeight(500)
	
	list_anker:SetScrollChild(list)
	
	
	
	if editid then
		local card = deepcopy(LBP_DB[editzone][editsubzone][editid]);
		local specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		local _, specname = GetSpecializationInfoByID(LBP_DB[editzone][editsubzone][editid]["Spec"]);
	
		editcard.editname:SetText(LBP_DB[editzone][editsubzone][editid]["Name"])
		editcard.editname:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Name"] = editcard.editname:GetText()
				frame:Build()
			end)
			
			
		editcard.tb_zone:SetText(editzone)

		editcard.tb_subzone:SetText(editsubzone)
		
	
		if card["Spec"] == specid then
			editcard.tb_spec:SetText("Spec: " .."|cff00FF00"..specname.."|r".."");
		else
			editcard.tb_spec:SetText("Spec: " .."|cffFF0000"..specname.."|r".."");
		end

		-- Talents
		for a = 1,6 do
			for b = 0,2 do
				s = tonumber(string.sub(card["Talents"],a,a));
						
			    if b==s then
					editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					editcard.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
					editcard.Talents[(a-1)*3+b+1]:SetHeight(32)
					editcard.Talents[(a-1)*3+b+1]:SetWidth(32)
					
					editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[editzone][editsubzone][editid]["Talents"] = string.sub(card["Talents"],1,a-1).."3"..string.sub(card["Talents"],a+1,6); frame:Build() end)
				else
					editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(1);
					editcard.Talents[(a-1)*3+b+1]:SetHeight(24)
					editcard.Talents[(a-1)*3+b+1]:SetWidth(24)
				
					editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[editzone][editsubzone][editid]["Talents"] = string.sub(card["Talents"],1,a-1)..b..string.sub(card["Talents"],a+1,6); frame:Build() end)
				end
			end
		end
		
		
		-- Glpyhs
		
		local glyphtable = LBP:GetGlyphTable(); -- get the current glphs
		local copy = deepcopy(card["Glyphs"])
		
		
		for slot, value in pairs(glyphtable) do
			local glyphtype = value[1]
			editcard.Glyph[slot]:SetGlyph("Interface/PaperDoll/UI-Backpack-EmptySlot", true)
				editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
					local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
					glyphlist_rahmen:Build("Interface/PaperDoll/UI-Backpack-EmptySlot", value[1])
					glyphlist_rahmen:ClearAllPoints()
					glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
					if relativeTo == editcard.Glyph[slot] then
						glyphlist_rahmen:Toggle()
					else
						glyphlist_rahmen:Show()
					end
				end)
			
			for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
				editcard.Glyph[slot]:SetGlyph(icon, true)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				
				editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
					local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
					glyphlist_rahmen:Build(icon, value[1])
					glyphlist_rahmen:ClearAllPoints()
					glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
					if relativeTo == editcard.Glyph[slot] then
						glyphlist_rahmen:Toggle()
					else
						glyphlist_rahmen:Show()
					end
				end)
				
				copy[tostring(glyphtype)][icon] = nil;
				break
			end
		end
		
		
--[[
		for slot,value in pairs(glyphtable) do
			editcard.Glyph[slot]:SetGlyph("Interface/ICONS/INV_MISC_QUESTIONMARK", true)
			
			local glyphtype = value[1];
			local icon = value[2];
			
			
			for index, glyphid in pairs(copy[tostring(glyphtype)]) do
	
				if icon == index then
					editcard.Glyph[slot]:SetGlyph(icon, true)
					editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
					editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					glyphtable[slot] = nil;
					copy[tostring(glyphtype)][index] = nil;
				end
			end		
			editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
				local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
				glyphlist_rahmen:Build(icon, value[1])
				glyphlist_rahmen:ClearAllPoints()
				glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
				if relativeTo == editcard.Glyph[slot] then
					glyphlist_rahmen:Toggle()
				else
					glyphlist_rahmen:Show()
				end
			end)
		end
		
		for slot, value in pairs(glyphtable) do
			local glyphtype = value[1]
			for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
				editcard.Glyph[slot]:SetGlyph(icon, false)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				copy[tostring(glyphtype)][icon] = nil;
				break
			end
		end
--]]		
		

		-- Macros
		if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
		if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
		if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
		if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end
	
		local name, iconTexture, body = GetMacroInfo("LBP Macro 3");
			editcard.macroframe3:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			editcard.macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe3); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
			editcard.macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 4");
			editcard.macroframe4:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			editcard.macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe4); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
			editcard.macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
		
		
		

		editcard.editbox_macro1_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro1_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro1"])
		editcard.editbox_macro1_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro1"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, editcard.editbox_macro1_editbox:GetText())
				
				local name, iconTexture, body = GetMacroInfo("LBP Macro 1");
				editcard.macroframe1:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe1:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe1); GameTooltip:SetText(card["Macro1"]); GameTooltip:Show(); end)
				editcard.macroframe1:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			end
		)
		editcard.editbox_macro1:UpdateScrollChildRect()
		editcard.editbox_macro1_editbox:SetCursorPosition(0)
		editcard.editbox_macro1:SetVerticalScroll(0)
		
		
		
		editcard.button_m1.text = LBP_DB[editzone][editsubzone][editid]["Macro1"];
		editcard.button_m1:SetScript("OnClick", 
			function(self) 
				editcard.editbox_macro1_editbox:SetText(editcard.button_m1.text)
			end)
		
		
		
		
		
		
		
		
		editcard.editbox_macro2_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro2_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro2"])
		editcard.editbox_macro2_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro2"] = editcard.editbox_macro2_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, editcard.editbox_macro2_editbox:GetText())
				
				local name, iconTexture, body = GetMacroInfo("LBP Macro 2");
				editcard.macroframe2:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe2); GameTooltip:SetText(card["Macro2"]); GameTooltip:Show(); end)
				editcard.macroframe2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			end
		)
		editcard.editbox_macro2:UpdateScrollChildRect()
		editcard.editbox_macro2_editbox:SetCursorPosition(0)
		editcard.editbox_macro2:SetVerticalScroll(0)
		
		
		editcard.button_m2.text = LBP_DB[editzone][editsubzone][editid]["Macro2"];
		editcard.button_m2:SetScript("OnClick", 
			function(self) 
				editcard.editbox_macro2_editbox:SetText(editcard.button_m2.text)
			end)
		--[[
		editcard.editbox_macro3_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro3_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro3"])
		editcard.editbox_macro3_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro3"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 3"),"LBP Macro 3",nil, editcard.editbox_macro3_editbox:GetText())
			end
		)
		editcard.editbox_macro3:UpdateScrollChildRect()
		editcard.editbox_macro3_editbox:SetCursorPosition(0)
		editcard.editbox_macro3:SetVerticalScroll(0)
		
		editcard.editbox_macro4_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro4_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro4"])
		editcard.editbox_macro4_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro4"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 4"),"LBP Macro 4",nil, editcard.editbox_macro1_editbox:GetText())
			end
		)
		editcard.editbox_macro4:UpdateScrollChildRect()
		editcard.editbox_macro4_editbox:SetCursorPosition(0)
		editcard.editbox_macro4:SetVerticalScroll(0)
		--]]
	end

	
	
	
	
	
	
	if editid then
		editcard:Show()
	else	
		editcard:Hide()
	end
	
	return
			
end

		
			
			

	frame:Build()
	
	frame:Hide()
	
	return frame
end



function LBP.CreateCard( self, parent )

	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "TOP", parent, "BOTTOM", 0, 0, 270, 270)
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
--	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/BUTTONS/WHITE8X8", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	
	local readyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
		readyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-Ready"});
		
	--local notreadyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
--		notreadyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-NotReady"});
	
	
	
	frame.SpecIcon_frame = LBP:CreateFrame("frame", "Templatecard_SpecIcon", frame, nil, "TOPLEFT", frame, "TOPLEFT", 10, -10, 32, 32)

		frame.SpecIcon = frame.SpecIcon_frame:CreateTexture("SpecIcon")
		frame.SpecIcon:SetTexture("Interface/ICONS/INV_MISC_QUESTIONMARK");
		frame.SpecIcon:SetAllPoints()
		
	frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", frame.SpecIcon, "TOPRIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
	frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)
	
	local editbutton = LBP.CreateCloseButton(self, frame, "Templatecard_editbutton", 24, "TOPRIGHT", frame, "TOPRIGHT", -4, -4)
		editbutton:SetNormalTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Up")
		editbutton:SetPushedTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Down")
		editbutton:SetScript("OnClick", 
			function(self) 
				LBPConfigframe:SetTemplate(parent.zonetext, parent.subzonetext, parent.id)
				LBPConfigframe:Show()
				LBPConfigframe:Build()
				parent:Hide()
			end)
		
	frame.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, frame, nil, "CENTER", frame, "TOPLEFT", mod(a-1,3)*32+26, -ceil(a/3)*32-40,  32, 32)
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()

		frame.Talents[a] = tmpframe;
		frame.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		frame.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		--frame.Talents[a]:SetScript("OnMouseUp", function() if PlayerTalentFrame and PlayerTalentFrame:IsVisible() then PlayerTalentFrame_Close() else ToggleTalentFrame() PlayerTalentFrame_Open() end end)
		frame.Talents[a]:SetScript("OnMouseUp", function() ToggleTalentFrame() PlayerTalentFrame_Open() end)
	end

	--frame.prepared
	
	local isSet, shouldbe, a,b, prepared
	
	function frame:CheckTalents()
		prepared = true
		for a = 1,6 do
			for b = 0,2 do
				_, _, _, _, isSet = GetTalentInfo((a-1)*3+b+1)
				shouldbe = tonumber(string.sub(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Talents"],a,a));
				
				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(1);
				frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				frame.Talents[(a-1)*3+b+1]:SetHeight(24)
				frame.Talents[(a-1)*3+b+1]:SetWidth(24)
				
				if b == shouldbe then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
					frame.Talents[(a-1)*3+b+1]:SetHeight(32)
					frame.Talents[(a-1)*3+b+1]:SetWidth(32)
				elseif isSet then --and s < 3 and b~=s then
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,0,0,1);
					prepared = false
				end
			end
		end
		
		return prepared
	end
	
		
	local glyphposition = {
		["x"] = {24+4, 0, -24-4, -20-4, 0, 20+4},
		["y"] = {2, 10, 2, -2, -16, -2},
		["point"] = {"BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT", "TOPRIGHT", "TOP", "TOPLEFT" },
		["length"] = {40,48,40,48,40,48},
	}
	
		
	frame.Glyph = {};
	
	for a=1,6 do
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, glyphposition["point"][a], frame, "TOPRIGHT", glyphposition["x"][a]-80, glyphposition["y"][a]-40-32+16-48-10, glyphposition["length"][a], glyphposition["length"][a])
		
		tmpframe:SetBackdrop({
				bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			})
			
		tmpframe.icon = "Interface/ICONS/INV_MISC_QUESTIONMARK"
		tmpframe:SetScript("OnMouseUp", function() ToggleTalentFrame(); OpenGlyphFrame() end)
			
		function tmpframe:SetGlyph(icon, tmp)
			if icon and icon ~= tmpframe.icon then 
				tmpframe:SetBackdrop({bgFile = icon}) tmpframe.icon = icon 
				icon = true
			else
				icon = false
			end
			
			if tmp then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
			return icon
		end
		
		
	frame.Glyph[a] = tmpframe;
	end

	
	local currentGlyphs = LBP:GetGlyphTable();  -- Glyphen die drin sind
	
	local shouldbeicon = {}
	local shouldbeid = {}
	
	local index,value,icon, glyph_id, a, b, drin
	local shouldbe = {}
	

	
	--LBP_DB[zone][subzone][id]["Glyphs"]
	
	function frame:CheckGlyphs()
	
		currentGlyphs = LBP:GetGlyphTable()
		prepared = true;
		
		
		
		for a = 1,6 do
			shouldbe[a] = currentGlyphs[a][2]
		end
		
		
		for c = 1,2 do -- first major, than minor glyphs
		
		-- checks if the current glyph is in the list
		for a = c,6,2 do
			drin = false
			
			for icon, glyph_id in pairs(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)]) do
				if icon == shouldbe[a] then
				
					drin = true
					break
				end
			end
			
			-- if not, goes through the list. if a glyph from the list is not set yet, and sets it

			if not drin then
		
				for icon, glyph_id in pairs(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)]) do
				drin = false
					for b = c,6,2 do
						if icon == shouldbe[b] then
							drin = true
							break
						end
					end
					if not drin then
						shouldbe[a] = icon
						prepared = false
					end
				end
			end
		end
		
		end
		
		for c = 1,2 do
		for a = c,6,2 do
		--print(GetTime())
			if shouldbe[a] == currentGlyphs[a][2] then
				if frame.Glyph[a]:SetGlyph(shouldbe[a], true) then
					frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(currentGlyphs[a][3]); GameTooltip:Show(); end)
					frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				end
			else
				if frame.Glyph[a]:SetGlyph(shouldbe[a], false) then
					frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Glyphs"][tostring(3-c)][shouldbe[a]]); GameTooltip:Show(); end)
					frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				end
			end
		end
		end
		
	
		return prepared
	end
	


	
	local macro_iconTexture
			
	
	frame.macroframe = {};
	
	for a=1,4 do
		frame.macroframe[a] = LBP:CreateFrame("frame", "Macroframe"..a, frame, nil, "TOPRIGHT", frame, "TOPRIGHT", -10+(a-4)*36, -200, 32, 32);
		frame.macroframe[a]:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
		frame.macroframe[a].bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK";
		frame.macroframe[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
	end

	
	
	local alpha = 1;
	
	
	local body
		
	function frame:Update()
	
		frame.prepared = true;
	
		if not InCombatLockdown() then
		
			specid, spec, description, icon, background, role = GetSpecializationInfoByID(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Spec"]);
			
			frame.SpecIcon:SetTexture(icon)
	
		
			specid = GetSpecializationInfo(GetSpecialization());
			
			if LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Spec"] == specid then
				frame.TemplateSpec:SetText("|cff00FF00"..spec.."|r");
				frame.SpecIcon:SetDesaturated(0);
				frame.SpecIcon:SetVertexColor(1.0, 1.0, 1.0)
			else
				frame.TemplateSpec:SetText("|cffFF0000"..spec.."|r");
				frame.SpecIcon:SetDesaturated(1);
				frame.SpecIcon:SetVertexColor(1.0, 0.0, 0.0)
				frame.prepared = false;
			end
			
			frame.TemplateName:SetText(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Name"].."\n");

			if not frame:CheckTalents() then
				frame.prepared = false;
			end
		
			if not frame:CheckGlyphs() then
				frame.prepared = false;
			end


			for a=1,4 do
				if not LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] then LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] = "/script print(\"LBP: Macro #"..a.."\")"; end
				
				body = GetMacroBody("LBP Macro "..a)
				
				if body ~= LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a] then	
					EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a]) 
					frame.macroframe[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.macroframe[a]); GameTooltip:SetText(LBP_DB[parent.zonetext][parent.subzonetext][parent.id]["Macro"..a]); GameTooltip:Show(); end)
				end
			
				_, macro_iconTexture = GetMacroInfo("LBP Macro "..a);
			

				if macro_iconTexture ~= frame.macroframe[a].bgFile then
					frame.macroframe[a]:SetBackdrop({bgFile = macro_iconTexture });
					frame.macroframe[a].bgFile = macro_iconTexture;
				end
			end
				
			if frame.prepared then
				frame:SetBackdropColor(0, 0, 0 , .85)
				--notreadyframe:Hide()
				readyframe:Show()
			else
				frame:SetBackdropColor(.3, 0, 0 , .85)
				readyframe:Hide()
				--notreadyframe:Show()
			end

		end
	end
	

	
	frame:Hide()
	return frame
end



function LBP.CreateWindow(self)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "CENTER", UIParent, "CENTER", 0, 350, 220, 50)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/BUTTONS/UI-SliderBar-Border", edgeSize = 4, insets = { left = 0, right = 0, top = 3, bottom = 2 } });
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:Show()
	
	frame.button = LBP.CreateCloseButton(self, frame, "Window_CloseButton", 24, "TOPRIGHT", frame, "TOPRIGHT", -1, -1)
		frame.button:SetScript("OnClick", function(self) frame:Hide() frame:SetAlpha(-2) end)
		
	local alpha = 1
	
	local zonetext = GetZoneText();
	local subzonetext = GetSubZoneText();
	
	frame.zonetext = GetZoneText()
	frame.subzonetext = GetSubZoneText()
	frame.id = nil
	
	
	tinsert(UISpecialFrames,"LBPMainFrame");
	
	frame.prepared = false;
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "CENTER", frame, "CENTER", 0, 0, 220-24-24, 14*3, "CENTER", "MIDDLE", 1, 1, 1, 1)
		textbox:SetText("Zonetext and Subzonetext")

		
	local zone
	local subzone
	--if not frame.zone then frame.zone = GetZoneText() end
	--if not frame.subzone then frame.subzone = GetSubZoneText() end
	
	--frame.cards ={}
	frame.tabs ={}
	
	
	

function frame:CreateTab( parent, zone, subzone, id)

	local card = deepcopy(LBP_DB[zone][subzone][id]);
	
	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "CENTER", parent, "CENTER", 0, 0, 220, 52)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
--	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/ACHIEVEMENTFRAME/UI-Achievement-WoodBorder",tile = false, tileSize = 16, edgeSize = 32, insets = { left = 4, right = 4, top = 4, bottom = 4 } })
	
	
	local specidid, name, description, icon, background, role, class = GetSpecializationInfoByID(LBP_DB[zone][subzone][id]["Spec"])

	
	--frame.SpecIcon = LBP:CreateFrame("frame", "Templatecard_SpecIcon", frame, nil, "TOPLEFT", frame, "TOPLEFT", 10, -10, 32, 32)
			frame.SpecIcon = frame:CreateTexture("Texture")
			frame.SpecIcon:SetTexture(icon)
			frame.SpecIcon:SetDesaturated(1);
			frame.SpecIcon:SetPoint("TOPLEFT", frame, "TOPLEFT", 10, -10)
			frame.SpecIcon:SetPoint("BOTTOMRIGHT", frame, "TOPLEFT", 10+32, -10-32)

		--frame.SpecIcon:SetBackdrop({bgFile = icon });
		--frame.SpecIcon.icon = icon
		
	frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "LEFT", frame.SpecIcon, "RIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
	--frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)

	frame:SetScript("OnMouseUp", function(self)
		for index,value in pairs(LBP_DB[zone][subzone]) do
			value["active"] = false
		end
						
		LBP_DB[zone][subzone][id]["active"] = true;
				
		TimeSinceLastUpdate = 0
		
		for a = 1,4 do
			EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, LBP_DB[zone][subzone][id]["Macro"..a])
		end
		
		LBPMainFrame:Check()
		
	end)

	
	local spec, icon
		
	function frame:Update()

		_, spec, _, icon = GetSpecializationInfoByID(LBP_DB[zone][subzone][id]["Spec"]);
			
		frame.SpecIcon:SetTexture(icon)
		--if frame.SpecIcon.icon ~= icon then
--			frame.SpecIcon:SetBackdrop({bgFile = icon });
			--frame.SpecIcon.icon = icon
		--end

		--frame.TemplateSpec:SetText("|cff00FF00"..spec.."|r");
		frame.TemplateName:SetText(LBP_DB[zone][subzone][id]["Name"].."\n");
		
		--frame:SetWidth(math.max(frame.TemplateSpec:GetStringWidth(), frame.TemplateName:GetStringWidth())+10+32+10+10)
		--frame:SetWidth(frame.TemplateName:GetStringWidth()+10+32+10+10)
		
	
	end
	
	frame:Hide()
	
	return frame
end


	

	frame.anker = LBP:CreateFrame("frame", "LBPMainFrameAnker", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	local tmpanker = frame.anker;
	--local tmp = LBP:CreateFrame("frame", "tmp", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	
	local n

	local template = LBP:CreateCard( frame, zonetext, subzonetext, index)
		template:ClearAllPoints()
		template:SetPoint("TOP", frame, "BOTTOM", 0, 6)
		template:Show()
	
	
	function frame:BuildTabs()
		for zonetext in pairs(LBP_DB) do
			for subzonetext in pairs(LBP_DB[zonetext]) do
				n = 0;
				for index,value in pairs(LBP_DB[zonetext][subzonetext]) do
					if not frame.tabs[index] then
						frame.tabs[index] = frame:CreateTab( frame, zonetext, subzonetext, index);
						frame.tabs[index]:Hide()
					end
					
					n= n+1;
				end
				if n == 1 then 
					for index in pairs(LBP_DB[zonetext][subzonetext]) do
						LBP_DB[zonetext][subzonetext][index]["active"] = true
					end
				end
			end
		end
	end
	
	
		
	
	
	
	
	function frame:Check()
		
		
	
		frame:BuildTabs()
	
		zonetext = GetZoneText();
		subzonetext = GetSubZoneText();
		

		
		if LBP_DB[zonetext] and subzonetext then
			if LBP_DB[zonetext][subzonetext] then
				frame:Show()
				
				if frame.zonetext ~= zonetext then
					frame.zonetext = zonetext
					alpha = 1
				end
				if frame.subzonetext ~= subzonetext then
					frame.subzonetext = subzonetext
					alpha = 1
				end
			else
				frame:Hide()
				return
			end
		else
			frame:Hide()
			return			
		end
		
		if not InCombatLockdown() then
			
			
--			if frame.zone ~= zonetext or frame.subzone ~= subzonetext then
				--frame.zone = zonetext
				--frame.subzone = subzonetext
				
			textbox:SetText(zonetext.."\n"..subzonetext)
				

			

				--for index,value in pairs(frame.cards) do
--					value:Hide()
				--end
				
				for index,value in pairs(frame.tabs) do
					value:Hide()
				end
				
		--if n>0 then
			frame.anker:SetPoint("TOP", template, "BOTTOM", 0,2)
			tmpanker = frame.anker

			
			

		local point, relativeTo, relativePoint, xOffset, yOffset

			
			for index,value in pairs(LBP_DB[zonetext][subzonetext]) do	

				if LBP_DB[zonetext][subzonetext][index]["active"] then
					frame.id = index
					--frame.cards[index]:Show()
					--frame.cards[index]:SetPoint("TOP", frame, "BOTTOM", 0,0)
					template:SetScript("OnMouseUp", function() ToggleTalentFrame(); end)
									
					frame.tabs[index]:Hide()
				else
					frame.tabs[index]:Show()
					
					
					frame.tabs[index]:SetPoint("TOP", tmpanker, "BOTTOM", 0,4)
					tmpanker = frame.tabs[index]
					
					--frame.cards[index]:Hide()
				end
				
				
				
				
			end

		end
	end
	
	--[[
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		frame:Check()
		oldShow(...)
	end
	--]]
	
	
	frame:SetScript("OnUpdate", function(self)
		if time()-TimeSinceLastUpdate > 0 then
			if alpha == -2 then
				frame:Hide()
				return
			end
			for index in pairs(LBP_DB[zonetext][subzonetext]) do
				if LBP_DB[zonetext][subzonetext][index]["active"] then
					template:Update()

					if alpha < 0 then
						frame:Hide()
						return
					end
					
					if alpha <= 1 then
						if template.prepared then
							alpha = alpha - 0.001
							alpha = alpha - ((1-alpha)^3)/3
						else
							alpha = 1
						end	
					end
					frame:SetAlpha(alpha)	
				else
					alpha = 2
					frame.tabs[index]:Update()
				end
			end
			

			if alpha < 0 then
				--alpha = 1.1
				frame:Hide()
			elseif alpha >= 1 then
				TimeSinceLastUpdate = time()
			end
		end
	
	
	end)
	
	
	
	
	
	
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		--frame:Check()
		TimeSinceLastUpdate = 0;
		oldShow(...)
	end
	
	local oldSetAlpha = frame.SetAlpha;
	
	frame.SetAlpha = function(self, a, ...)
		alpha = a;
		oldSetAlpha(self, a, ...)
	end
	
	
	
	
	
	
	
	
	
	frame:Hide()
	return frame
end


function LBP.GetTalentString(self)
	s = "";
	for b = 0,5 do
		for a = 1,3 do
			local name, iconTexture, tier, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(b*3+a)
			if rank then s = s..a-1; end
			
	
		end
	end
	return s
end



local glyphType, icon
local icon2, castSpell
local a,b
local s = {};

function LBP.GetGlyphTable(self)
	for b = 1,6 do
		if not s[b] then s[b] = {} end
		_, glyphType, _, _, icon = GetGlyphSocketInfo(b)
		
		for a=1,GetNumGlyphs() do 
			_, _, _, icon2, castSpell = GetGlyphInfo(a)
			if icon2 == icon then 
				s[b][1] = glyphType
				s[b][2] = icon
				s[b][3] = castSpell
				break 
			end
		end
	end
	return s
end





function LBP.OnEvent( self, event, name, ...)
	if event=="UPDATE_MACROS" then
		if not InCombatLockdown() then
			local numglobal,numperchar = GetNumMacros();
			
			if numglobal > 32 then
				LBP:echo("Not enough space to create the macros. LBP needs four free macro slots")
				EventFrame:UnregisterAllEvents();
			else
				if not GetMacroInfo("LBP Macro 1") then
					CreateMacro("LBP Macro 1", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #1\")", nil);
				end
				if not GetMacroInfo("LBP Macro 2") then
					CreateMacro("LBP Macro 2", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #2\")", nil);
				end
				if not GetMacroInfo("LBP Macro 3") then
					CreateMacro("LBP Macro 3", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #3\")", nil);
				end
				if not GetMacroInfo("LBP Macro 4") then
					CreateMacro("LBP Macro 4", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #4\")", nil);
				end
			end
		end
	end
	if event=="VARIABLES_LOADED" then
		EventFrame:UnregisterEvent("ADDON_LOADED");
		
		
		
		
		
			
					
		local readycheck = LBP:CreateFrame("frame", "LBPReadyCheck", ReadyCheckFrame, nil, "TOP", ReadyCheckFrame, "BOTTOM", 0, -10, 315, 32)
			readycheck:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			
			readycheck.list = {}	
		
		local _, _, _, numSpells = GetSpellTabInfo(1)
		local _, _, _, numSpells2 = GetSpellTabInfo(2)
		local a
		
		local n
		local start, duration, enable
		local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(a, "spell")
		local CD
		local tmpframe
		
	readycheck:SetScript("OnUpdate", function(self)

		readycheck:ClearAllPoints()
		readycheck:SetPoint("TOP", ReadyCheckFrame, "BOTTOM", 0, 0)		
		
		n = 0;
		
		for a = numSpells+1, numSpells+numSpells2 do
			start, duration, enable = GetSpellCooldown(a, "spell")
	
			if duration < 2 then
				if readycheck.list[a] then readycheck.list[a]:Hide() end
			else
		
				readycheck:SetHeight(32)
			
				name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(a, "spell")
				CD = math.ceil(duration-GetTime()+start);
		
		
				if not readycheck.list[a] then
					tmpframe = LBP:CreateFrame("frame", "LBPReadyCheck"..a, readycheck, nil, "TOPLEFT", readycheck, "TOPLEFT", 10, 0, 300, 48)
					tmpframe.icon = LBP:CreateFrame("frame", "LBPReadyCheckicon"..a, tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 48, 48)
						tmpframe.icon:SetBackdrop({bgFile = icon });
					tmpframe.icontext = LBP:CreateFontString(tmpframe.icon, "icontext"..a,"ARTWORK", "GameFontNormalLarge", "TOPLEFT", tmpframe.icon, "TOPLEFT", 0, 0, 48, 48, "CENTER", "MIDDLE", 1, 1, 1, 1)
						tmpframe.icontext:SetText("B")
					tmpframe.textbox = LBP:CreateFontString(tmpframe.icon, "textbox"..a,"ARTWORK", "GameFontNormalLarge", "LEFT", tmpframe.icon, "RIGHT", 10, 0, 200, 48, "LEFT", "MIDDLE", 1, 1, 1, 1)
						tmpframe.textbox:SetText(name)
				
					function tmpframe.SetCD(self, CD)
						tmpframe.icontext:SetText(CD)
					end
			
					readycheck.list[a] = tmpframe
				end	
			
				;
		
				
					readycheck.list[a]:SetCD(CD)
					readycheck.list[a]:ClearAllPoints()
					readycheck.list[a]:SetPoint("TOPLEFT", readycheck, "TOPLEFT", 10, -n*54-10)
					readycheck.list[a]:Show()
				n = n+1;
			end
		end		
		
		-- Moonkin functions
		if GetSpecializationInfo(GetSpecialization()) == 102 then
		
				if not readycheck.list["druid_mushrooms"] then
					tmpframe = LBP:CreateFrame("frame", "LBPReadyCheck", readycheck, nil, "TOPLEFT", readycheck, "TOPLEFT", 10, 0, 300, 48)
					tmpframe.icon = LBP:CreateFrame("frame", "LBPReadyCheckicon", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 48, 48)
						tmpframe.icon:SetBackdrop({bgFile = "Interface/ICONS/druid_ability_wildmushroom_a" });
					tmpframe.icontext = LBP:CreateFontString(tmpframe.icon, "icontext","ARTWORK", "GameFontNormalLarge", "TOPLEFT", tmpframe.icon, "TOPLEFT", 0, 0, 48, 48, "CENTER", "MIDDLE", 1, 1, 1, 1)
						tmpframe.icontext:SetText("B")
					tmpframe.textbox = LBP:CreateFontString(tmpframe.icon, "textbox","ARTWORK", "GameFontNormalLarge", "LEFT", tmpframe.icon, "RIGHT", 10, 0, 200, 48, "LEFT", "MIDDLE", 1, 1, 1, 1)
						tmpframe.textbox:SetText(name)
				
					function tmpframe.SetCD(self, CD)
						tmpframe.icontext:SetText(CD)
					end
			
					readycheck.list["druid_mushrooms"] = tmpframe
				end	
				
			if not GetTotemInfo(3) then
				readycheck.list["druid_mushrooms"].textbox:SetText("Erst zwei Pilze gesetzt")
				if not GetTotemInfo(2) then
					readycheck.list["druid_mushrooms"].textbox:SetText("Erst einen Pilz gesetzt")
				end
				if not GetTotemInfo(1) then
					readycheck.list["druid_mushrooms"].textbox:SetText("Noch keinen Pilz gesetzt")
				end				
				
					readycheck.list["druid_mushrooms"]:SetCD(" ")
					
					readycheck.list["druid_mushrooms"]:ClearAllPoints()
					readycheck.list["druid_mushrooms"]:SetPoint("TOPLEFT", readycheck, "TOPLEFT", 10, -n*54-10)
					readycheck.list["druid_mushrooms"]:Show()
				n = n+1;
			else
				readycheck.list["druid_mushrooms"]:Hide()
			end
		end
		
		readycheck:SetHeight(48+(n-1)*54+20)

		if n <1 then
			readycheck:ClearAllPoints()
			readycheck:SetPoint("TOP", ReadyCheckFrame, "BOTTOM", 0, 100000)
		end
		
	end)

		
		
		EventFrame:SetScript("OnUpdate", 
			function(self, event, ... ) 
				local _, iconTexture = GetTalentInfo(18) 
				if iconTexture then 
				
					EventFrame:SetScript("OnUpdate", nil)
					
					
					LBPMainframe = LBP:CreateWindow();
					LBPConfigframe = LBP:CreateConfig(); 
					
					LBPMainframe:Hide()
					LBPConfigframe:Hide()
					
					
					
					
					
	-- neue struktur, diese umwandlung fliegt in ein paar versionen raus				
		for zone in pairs (LBP_DB) do
			for subzone in pairs (LBP_DB[zone]) do
				for id in pairs (LBP_DB[zone][subzone]) do
					if not LBP_DB[zone][subzone][id]["Glyphs"]["1"] then
					
						local bla = {};
						bla["1"] = {};
						bla["2"] = {};
					
					
						for index in pairs (LBP_DB[zone][subzone][id]["Glyphs"]) do

							local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(index)
							
							if icon then
							
							
								local glyphid = 0;
								for a=1,GetNumGlyphs() do 
									local name, glyphType, isKnown, icon2, castSpell,link, subText = GetGlyphInfo(a)
								
									
									if icon2 == icon then glyphid = castSpell break end
								
								end

								bla[tostring(LBP_DB[zone][subzone][id]["Glyphs"][index])][icon] = glyphid;
								
								LBP_DB[zone][subzone][id]["Glyphs"][index] = nil
							end
						end
						LBP_DB[zone][subzone][id]["Glyphs"] = bla
					
					end
				end
			end
		end					
					



		for zone in pairs (LBP_DB) do
			for subzone in pairs (LBP_DB[zone]) do
				for id in pairs (LBP_DB[zone][subzone]) do
					if type(LBP_DB[zone][subzone][id]["Spec"]) == "string" then
						for a = 1,4 do
							local specid, name = GetSpecializationInfo(a)
							if LBP_DB[zone][subzone][id]["Spec"] == name then
								LBP_DB[zone][subzone][id]["Spec"] = specid
							end
						end
					end
				end
			end
		end					
					
					
					
					
					
					
					
					
					
					
					
				end 
			end
		)
		
		
	
		-- Macros

		
--		LBPOnUpdateframe = LBP:CreateFrame("frame", "LBPOnUpdateFrame", UIParent, nil, "TOPLEFT", UIParent, "TOPLEFT", 0, 0, 10, 10)
		--LBPOnUpdateframe:SetScript("OnUpdate", function(self, event, ... ) LBP:OnUpdate(event, ...) end)

	
	
	
	

	
	
	
	
	
	
	end	
	
	
	
	
	
	if not InCombatLockdown() and LBPMainframe and not LBPConfigframe:IsVisible() then
		--LBPMainframe.zone = GetZoneText();
		--LBPMainframe.subzone = GetSubZoneText();
		
		LBPMainframe:Check()	
	end
end											



function LBP.initialize(self)													-- Beginn initialize

	SlashCmdList["LBP"] = function( ) LBPMainframe:SetAlpha(2) LBPMainframe:Check() end
	SLASH_LBP1 = "/LBP";
	SLASH_LBP1 = "/lbp";
	
	EventFrame = CreateFrame( "Frame", "LBPEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) LBP:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("UPDATE_MACROS");
	EventFrame:RegisterEvent("ZONE_CHANGED");
	EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	EventFrame:RegisterEvent("READY_CHECK");
	--LBPObject = LBPLayoutObj()
	
						
	
	LBP:echo("LBP initialized...")

end	

-- Ende initialize


-- Hilfsfunktionen zum Erstellen von Frames

function LBP.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function LBP.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
		fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		fontstring:SetWidth(width)
		fontstring:SetHeight(height)
		fontstring:SetJustifyH(justifyH)
		fontstring:SetJustifyV(justifyV)
		fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end


function LBP.CreateCloseButton(self, frame, name, width, point, relativeTo, relativePoint, xOffset, yOffset)
	local button = CreateFrame("BUTTON", name, frame, "UIPanelButtonTemplate")
		button:SetWidth(width)
		button:SetHeight(width)
		button:SetNormalTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Up")
		button:SetPushedTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Down")
	
	local NormalTexture = button:GetNormalTexture()
		NormalTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
		NormalTexture:ClearAllPoints()
		NormalTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
		NormalTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	
	local PushedTexture = button:GetPushedTexture()	
		PushedTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
		PushedTexture:ClearAllPoints()
		PushedTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
		PushedTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
		
		
		button:SetScript("OnClick",	function(self) frame.button:GetParent():Hide()	end)
		
		if point and relativeTo and relativePoint and xOffset and yOffset then
			button:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		end
	
	return button
end

LBP.initialize()





